package com.zcloud.controller.emergency;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.emergency.EmergencyDrillBasicService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：应急方案基本信息
 * 作者：luoxiaobao
 * 时间：2021-06-19
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/emergencydrillbasic")
public class EmergencyDrillBasicController extends BaseController {

	@Autowired
	private EmergencyDrillBasicService emergencydrillbasicService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions("emergencydrillbasic:add")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "应急资源管理",instructionsOperate = "应急演练管理",instructionsType = "新增")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("EMERGENCYDRILLBASIC_ID", this.get32UUID());	//主键
		pd.put("CREATOR", Jurisdiction.getUsername());	//添加人
		pd.put("CREATTIME", DateUtil.date2Str(new Date()));	//添加时间
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		pd.put("ISDELETE", "0");	//是否删除 1-是  0-否
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		emergencydrillbasicService.save(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("emergencydrillbasic:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "应急资源管理",instructionsOperate = "应急演练管理",instructionsType = "删除")
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		emergencydrillbasicService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("emergencydrillbasic:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "应急资源管理",instructionsOperate = "应急演练管理",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		emergencydrillbasicService.edit(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("emergencydrillbasic:list")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "应急资源管理",instructionsOperate = "应急演练管理",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		page.setPd(pd);
		List<PageData>	varList = emergencydrillbasicService.list(page);	//列出EmergencyDrillBasic列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("emergencydrillbasic:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "应急资源管理",instructionsOperate = "应急演练管理",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = emergencydrillbasicService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("emergencydrillbasic:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "应急资源管理",instructionsOperate = "应急演练管理",instructionsType = "批量删除")
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			pd.put("ArrayDATA_IDS", ArrayDATA_IDS);	//待删除ids
			emergencydrillbasicService.deleteAll(pd);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	@LogAnno(menuType= "综合管理",menuServer= "应急资源管理",instructionsOperate = "应急演练管理",instructionsType = "导出到excel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("应急演练方案名称");	//1
		titles.add("演练单位");	//2
		titles.add("演练时间");	//3
		titles.add("演练目的");	//4
		titles.add("演练特点");	//5
		titles.add("应急演练地点");	//6
		titles.add("参加人员");	//7
		titles.add("添加人部门ID");	//8
		titles.add("是否删除");	//9
		titles.add("修改人");	//10
		titles.add("修改时间");	//11
		titles.add("添加时间");	//12
		titles.add("添加人");	//13
		dataMap.put("titles", titles);
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		List<PageData> varOList = emergencydrillbasicService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("DRILL_NAME"));	    //1
			vpd.put("var2", varOList.get(i).getString("DRILL_UNIT"));	    //2
			vpd.put("var3", varOList.get(i).getString("DRILL_DATE"));	    //3
			vpd.put("var4", varOList.get(i).getString("DRILL_PURPOSE"));	    //4
			vpd.put("var5", varOList.get(i).getString("DRILL_PROPERTY"));	    //5
			vpd.put("var6", varOList.get(i).getString("DRILL_PLACE"));	    //6
			vpd.put("var7", varOList.get(i).getString("DRILL_ATTENDERS"));	    //7
			vpd.put("var8", varOList.get(i).getString("CREATOR_DEPARTMENT_ID"));	    //8
			vpd.put("var9", varOList.get(i).getString("ISDELETE"));	    //9
			vpd.put("var10", varOList.get(i).getString("OPERATOR"));	    //10
			vpd.put("var11", varOList.get(i).getString("OPERATTIME"));	    //11
			vpd.put("var12", varOList.get(i).getString("CREATTIME"));	    //12
			vpd.put("var13", varOList.get(i).getString("CREATOR"));	    //13
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
